<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// $Id: notifymsgs.php 75 2010-04-01 19:40:08Z egalstad $

require_once(dirname(__FILE__).'/../includes/common.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication();


// route request
route_request();


function route_request(){
	global $request;

	if(isset($request['update']))
		do_updateprefs();
	else
		show_updateprefs();
	exit;
	}
	
	
function show_updateprefs($error=false,$msg=""){
	global $request;
	global $lstr;
	global $notificationmethods;
	
	
	// check contact details
	$contact_name=get_user_attr(0,"username");
	$arr=get_user_nagioscore_contact_info($contact_name);
	$is_nagioscore_contact=$arr["is_nagioscore_contact"];  // is the user a Nagios Core contact?
	$has_nagiosxi_timeperiod=$arr["has_nagiosxi_timeperiod"]; // does the contact have XI notification timeperiod?
	$has_nagiosxi_commands=$arr["has_nagiosxi_commands"]; // does the contact have XI notification commands?

	// defaults
	$host_email_subject=get_user_host_email_notification_subject(0);
	$host_email_message=get_user_host_email_notification_message(0);
	$service_email_subject=get_user_service_email_notification_subject(0);
	$service_email_message=get_user_service_email_notification_message(0);
	
	$host_mobiletext_subject=get_user_host_mobiletext_notification_subject(0);
	$host_mobiletext_message=get_user_host_mobiletext_notification_message(0);
	$service_mobiletext_subject=get_user_service_mobiletext_notification_subject(0);
	$service_mobiletext_message=get_user_service_mobiletext_notification_message(0);

	
	// grab form variable values
	
	do_page_start(array("page_title"=>$lstr['NotificationMessagesPageTitle']),true);
?>

	<h1><?php echo $lstr['NotificationMessagesPageHeader'];?></h1>
	

<?php
	display_message($error,false,$msg);
?>

<?php
	if($has_nagiosxi_commands==false){
		echo $lstr['UserIsNotContactNotificationMessagesErrorMessage'];
		}
	else{
?>

	<?php echo $lstr['NotificationMessagesMessage'];?>

	<form id="updateNotificationPreferencesForm" method="post" action="">
	<input type="hidden" name="update" value="1" />
	
	
	<div class="sectionTitle"><?php echo $lstr['EmailNotificationMessagesSectionTitle'];?></div>

	<?php echo $lstr['EmailNotificationMessagesMessage'];?>
	
	<br>
	<br>

	<table>

	<tr>
	<td>
	<label><?php echo $lstr['HostNotificationMessageSubjectBoxTitle'];?>:</label><br class="nobr" />
	</td>
	<td>
	<input type="text" size="65" name="host_email_subject" id="host_email_subject" value="<?php echo $host_email_subject;?>" class="textfield" /><br class="nobr" />
	</td>
	</tr>

	<tr>
	<td>
	<label><?php echo $lstr['HostNotificationMessageBodyBoxTitle'];?>:</label><br class="nobr" />
	</td>
	<td>
<textarea name="host_email_message" cols="50" rows="3">
<?php echo $host_email_message;?>
</textarea>
	</td>
	</tr>

	<tr>
	<td>
	<label><?php echo $lstr['ServiceNotificationMessageSubjectBoxTitle'];?>:</label><br class="nobr" />
	</td>
	<td>
	<input type="text" size="65" name="service_email_subject" id="service_email_subject" value="<?php echo $service_email_subject;?>" class="textfield" /><br class="nobr" />
	</td>
	</tr>

	<tr>
	<td>
	<label><?php echo $lstr['ServiceNotificationMessageBodyBoxTitle'];?>:</label><br class="nobr" />
	</td>
	<td>
<textarea name="service_email_message" cols="50" rows="3">
<?php echo $service_email_message;?>
</textarea>
	</td>
	</tr>

	</table>
	
	<div>
	<input type="submit" class="submitbutton" name="updateButton" value="<?php echo $lstr['UpdateSettingsButton'];?>" id="updateButton" />
	<input type="submit" class="submitbutton" name="cancelButton" value="<?php echo $lstr['CancelButton'];?>" id="cancelButton" />
	</div>
	
	<div class="sectionTitle"><?php echo $lstr['MobileTextNotificationMessagesSectionTitle'];?></div>

	<?php echo $lstr['MobileTextNotificationMessagesMessage'];?>
	
	<br>
	<br>

	<table>

	<tr>
	<td>
	<label><?php echo $lstr['HostNotificationMessageSubjectBoxTitle'];?>:</label><br class="nobr" />
	</td>
	<td>
	<input type="text" size="65" name="host_mobiletext_subject" id="host_mobiletext_subject" value="<?php echo $host_mobiletext_subject;?>" class="textfield" /><br class="nobr" />
	</td>
	</tr>

	<tr>
	<td>
	<label><?php echo $lstr['HostNotificationMessageBodyBoxTitle'];?>:</label><br class="nobr" />
	</td>
	<td>
<textarea name="host_mobiletext_message" cols="50" rows="3">
<?php echo $host_mobiletext_message;?>
</textarea>
	</td>
	</tr>

	<tr>
	<td>
	<label><?php echo $lstr['ServiceNotificationMessageSubjectBoxTitle'];?>:</label><br class="nobr" />
	</td>
	<td>
	<input type="text" size="65" name="service_mobiletext_subject" id="service_mobiletext_subject" value="<?php echo $service_mobiletext_subject;?>" class="textfield" /><br class="nobr" />
	</td>
	</tr>

	<tr>
	<td>
	<label><?php echo $lstr['ServiceNotificationMessageBodyBoxTitle'];?>:</label><br class="nobr" />
	</td>
	<td>
<textarea name="service_mobiletext_message" cols="50" rows="3">
<?php echo $service_mobiletext_message;?>
</textarea>
	</td>
	</tr>

	</table>
	

	<div>
	<input type="submit" class="submitbutton" name="updateButton" value="<?php echo $lstr['UpdateSettingsButton'];?>" id="updateButton" />
	<input type="submit" class="submitbutton" name="cancelButton" value="<?php echo $lstr['CancelButton'];?>" id="cancelButton" />
	</div>

<?php	

	foreach($notificationmethods as $name => $arr){
	
		$inargs=$request;
		$outargs=array();
		$result=0;
		
		$output=make_notificationmethod_callback($name,NOTIFICATIONMETHOD_MODE_GETMESSAGEFORMAT,$inargs,$outargs,$result);
		
		if($output!=''){
			echo $output;
?>
	<div>
	<input type="submit" class="submitbutton" name="updateButton" value="<?php echo $lstr['UpdateSettingsButton'];?>" id="updateButton" />
	<input type="submit" class="submitbutton" name="cancelButton" value="<?php echo $lstr['CancelButton'];?>" id="cancelButton" />
	</div>

<?php
			}
		}
?>
	
	</form>

<?php
		}
?>
	
	
<?php

	do_page_end(true);
	exit();
	}


function do_updateprefs(){
	global $request;
	global $lstr;
	global $notificationmethods;
	
	// user pressed the cancel button
	if(isset($request["cancelButton"]))
		header("Location: notifyprefs.php");
	
	$errmsg=array();
	$errors=0;
	

	// grab form variable values
	$messages=array();
	
	$messages["email"]["host"]["subject"]=grab_request_var("host_email_subject","");
	$messages["email"]["host"]["message"]=grab_request_var("host_email_message","");
	$messages["email"]["service"]["subject"]=grab_request_var("service_email_subject","");
	$messages["email"]["service"]["message"]=grab_request_var("service_email_message","");

	$messages["mobiletext"]["host"]["subject"]=grab_request_var("host_mobiletext_subject","");
	$messages["mobiletext"]["host"]["message"]=grab_request_var("host_mobiletext_message","");
	$messages["mobiletext"]["service"]["subject"]=grab_request_var("service_mobiletext_subject","");
	$messages["mobiletext"]["service"]["message"]=grab_request_var("service_mobiletext_message","");

	// check for errors
	if(in_demo_mode()==true)
		$errmsg[$errors++]=$lstr['DemoModeChangeError'];
		
	// make callbacks to other notification methods
	foreach($notificationmethods as $name => $arr){
	
		$inargs=$request;  // pass request vars to methods
		$outargs=array();
		$result=0;
		
		$output=make_notificationmethod_callback($name,NOTIFICATIONMETHOD_MODE_SETMESSAGEFORMAT,$inargs,$outargs,$result);
		
		// handle errors
		if($result!=0){
			if(array_key_exists(NOTIFICATIONMETHOD_ERROR_MESSAGES,$outargs)){
				foreach($outargs[NOTIFICATIONMETHOD_ERROR_MESSAGES] as $e)
					$errmsg[$errors++]=$e;
				}
			}
		}
	
	// handle errors
	if($errors>0)
		show_updateprefs(true,$errmsg);

	// set new prefs
	set_user_meta(0,"notification_messages",serialize($messages));

	// success!
	show_updateprefs(false,$lstr['NotificationsPrefsUpdatedText']);
	}
	

?>