<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// $Id: index.php 75 2010-04-01 19:40:08Z egalstad $

require_once(dirname(__FILE__).'/../includes/common.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication();

draw_page();



function draw_page(){
	global $lstr;
	
	if(is_authorized_to_configure_objects()==false)
		header("Location: ".get_base_url());
	
	$pageopt=grab_request_var("pageopt","");
	
	do_page_start(array("page_title"=>$lstr['ConfigPageTitle']),false);
?>
	<div id="leftnav">
	<?php draw_menu();?>
	</div>

	<div id="maincontent">
	<div id="maincontentspacer">
	<IFRAME src="<?php echo get_window_frame_url("main.php");?>" width="100%" frameborder="0" id="maincontentframe" name="maincontentframe">
	[Your user agent does not support frames or is currently configured not to display frames. ]
	</IFRAME>
	
	<div id="viewtools">
	<div id="popout">
	<a href="#"><img src="<?php echo get_base_url();?>/images/popout.png" border="0" alt="<?php echo $lstr['PopoutAlt'];?>" title="<?php echo $lstr['PopoutAlt'];?>"></a>
	</div>
	</div>
	
	</div>
	</div>
	


<?	
	do_page_end(false);
	}

function draw_menu(){
	$m=get_menu_items();
	draw_menu_items($m);
?>

<?php
	}
	

function get_menu_items(){

	$basedir=get_base_url();

	$mi=array();
	
	// Configuration
	$mi[]=array(
		"type" => "menusection",
		"title" => "Quick Tools",
		"opts" => array(
			//"id" => "myaccountquickview",
			"expanded" => true,
			"url" => "main.php",
			//"target" => ""
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Configuration Home",
		"opts" => array(
			"href" => "main.php",
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);
		
	// Configuration
	$mi[]=array(
		"type" => "menusection",
		"title" => "Configuration Wizards",
		"opts" => array(
			//"id" => "myaccountquickview",
			"expanded" => true,
			"url" => "monitoringwizard.php",
			//"target" => ""
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Monitoring Wizard",
		"opts" => array(
			"href" => "monitoringwizard.php",
			//"target" => ""
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);
		
	if(is_advanced_user()==true){
	
		// Advanced Configuration
		$mi[]=array(
			"type" => "menusection",
			"title" => "Advanced Configuration",
			"opts" => array(
				//"id" => "myaccountquickview",
				"expanded" => true,
				//"url" => "main.php",
				"url" => "nagioscorecfg/",
				//"target" => ""
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Core Config Manager",
			"opts" => array(
				"img" => theme_image("menuredirect.png"),
				"href" => "nagioscorecfg/",
				"target" => "_top"
				)
			);
		$mi[]=array(
			"type" => "menusectionend",
			"title" => "",
			"opts" => ""
			);
		}



	// More Configuration Options
	$mi[]=array(
		"type" => "menusection",
		"title" => "More Options",
		"opts" => array(
			"id" => "myaccountquickview",
			"expanded" => true,
			//"url" => "main.php",
			//"target" => ""
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "My Account Settings",
		"opts" => array(
			"img" => theme_image("menuredirect.png"),
			"href" => $basedir."account/",
			"target" => "_top"
			)
		);
	if(is_admin()==true){
		$mi[]=array(
			"type" => "link",
			"title" => "System Configuration",
			"opts" => array(
				"img" => theme_image("menuredirect.png"),
				"href" => $basedir."admin/?xiwindow=globalconfig.php",
				"target" => "_top"
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "User Management",
			"opts" => array(
				"img" => theme_image("menuredirect.png"),
				"href" => $basedir."admin/?xiwindow=users.php",
				"target" => "_top"
				)
			);
		}
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);
				
				
	return $mi;
	}
	


?>