<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: index.php 75 2010-04-01 19:40:08Z egalstad $

require_once(dirname(__FILE__).'/../includes/common.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication();

route_request();

function route_request(){
	global $request;
	
	$pageopt=grab_request_var("pageopt","");
	
	//$url="main.php";
	$url="nagioscorereports.php";
	
	switch($pageopt){
		default:
			draw_page($url);
			break;
		}
	}

function draw_page($frameurl){
	global $lstr;
	
	$pageopt=grab_request_var("pageopt","info");
	
	do_page_start(array("page_title"=>$lstr['ReportsPageTitle']),false);
?>
	<div id="leftnav">
	<?php draw_menu();?>
	</div>

	<div id="maincontent">
	<IFRAME src="<?php echo get_window_frame_url($frameurl);?>" width="100%" frameborder="0" id="maincontentframe" name="maincontentframe">
	[Your user agent does not support frames or is currently configured not to display frames. ]
	</IFRAME>
	</div>

<?	
	do_page_end(false);
	}

function draw_menu(){
	$m=get_menu_items();
	draw_menu_items($m);
?>

<?php
	}
	

function get_menu_items(){

	$includes_path=get_base_url()."/includes/";
	$this_page=get_current_url(false,true);
	$page_path=$includes_path."page-reports-main.php";

	$nagioscoreui_path=nagioscore_get_ui_url();
	
	$mi=array();
	
	// Quick
	/*
	$mi[]=array(
		"type" => "menusection",
		"title" => "Quick Tools",
		"opts" => array(
			"id" => "quickview",
			"expanded" => true,
			"url" => $page_path,
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Quick Report",
		"opts" => array(
			"href" => $page_path,
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);
	*/		

	// My reports
	/*
	$mi[]=array(
		"type" => "menusection",
		"title" => "My Reports",
		"opts" => array(
			"id" => "myreports",
			"expanded" => true,
			"url" => $page_path,
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Memorized Reports",
		"opts" => array(
			"href" => $page_path."?pageopt=memorized",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Historical Reports",
		"opts" => array(
			"href" => $page_path."?pageopt=scheduled",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Scheduled Reports",
		"opts" => array(
			"href" => $page_path."?pageopt=scheduled",
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);
	*/
				
	// XI reports
	/*
	$mi[]=array(
		"type" => "menusection",
		"title" => "XI Reports",
		"opts" => array(
			"id" => "xireports",
			"expanded" => true,
			"url" => $page_path,
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Availability",
		"opts" => array(
			"href" => $page_path."?pageopt=availability",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Recent Alerts",
		"opts" => array(
			"href" => $page_path."?pageopt=recentalerts",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Top Problems",
		"opts" => array(
			"href" => $page_path."?pageopt=topproblems",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Capacity Planning",
		"opts" => array(
			"href" => $page_path."?pageopt=capacityplanning",
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);
	*/
				
	// Legacy reports
	$mi[]=array(
		"type" => "menusection",
		//"title" => "Legacy Reports",
		"title" => "Nagios Core Reports",
		"opts" => array(
			"id" => "nagioscorereports",
			"expanded" => true,
			"url" => "nagioscorereports.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Availability",
		"opts" => array(
			"href" => $nagioscoreui_path."avail.php"
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Trends",
		"opts" => array(
			"href" => $nagioscoreui_path."trends.php"
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Alert History",
		"opts" => array(
			"href" => $nagioscoreui_path."history.php?host=all"
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Alert Summary",
		"opts" => array(
			"href" => $nagioscoreui_path."summary.php"
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Alert Histogram",
		"opts" => array(
			"href" => $nagioscoreui_path."histogram.php"
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Notifications",
		"opts" => array(
			"href" => $nagioscoreui_path."notifications.php?contact=all"
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);

	return $mi;
	}
	

?>


